#include<iostream>
using namespace std;
#include<stdlib.h>
#include<stdio.h>
#include<cstring>
#include<cstdio>
#include "SCteammanagement.h"


char* SHOW_STATUS(int i){
switch (i){
    case 0:  return "";
    case 1:  return "Not Out";
    case 2:  return "LBW";
    case 3:  return "Run Out";
    case 4:  return "Bowled Out";
    case 5:  return "Caught Out";
    default: return "Unknown";
    }
    return "unknown";
}

/***************************my score**********************************/
class myscore{
    int player1;
    int player2;
    int Ball_count;
    int Over;
    int Max_Over;
    int Out;
    int Max_out;
    teammanagement team1;
    int extra;
    int levelType;
    int input1,input2;
    int oppScore;
public:

    myscore();
    void show(void);
    void add_run(void);
    void wicket(void);
    void extra1(void);
    void over_complete(void);
    void autoScore();
};


myscore::myscore(){
    player1=0;
    player2=0;
    extra=0;
    Over=0;
    Out=0;
    Max_out=10;
    Ball_count=0;
    levelType=ChooseLevel();
    team1.teamtype=ChooseTeam();
    team1.management();                            // Initialize Team
    //system("cls");
    cout<<"\nEnter no of Overs in one Innings: ";
    cin>>Max_Over;

    autoScore();

    while(1){
        cout<<"\n                       batsman 1:";       //Chose
        cin>>player1;                                      //Opening
        team1.Set_Status(player1,1);                       //Batsman
        cout<<"                       batsman 2:";
        cin>>player2;
        team1.Set_Status(player2,1);

        if(player1>11 || player2>11 || player1==player2)
            cout<<"Invalid Entry Try Again!!";
        else break;
    }
}

/******************** Showing Entire Score **********************/
void myscore::show(void){
    system("cls");
    int option;

    cout<<"//////////////////////////////////////////////////"<<endl;
    cout<<"                   "<<team1.get_t_name()<<" Score                     "<<endl;
    cout<<"//////////////////////////////////////////////////"<<endl<<endl;

    for(int i=1;i<=Max_out;i++)
    {
        cout<<team1.get_name(i)<<"                          ";
        cout<<SHOW_STATUS(team1.get_status(i))<<"                    ";
        cout<<team1.get_run(i);
        if(team1.get_status(i))cout<<"("<<team1.get_ball(i)<<")";
        cout<<endl;
    }

    cout<<"\nExtra ";
    cout<<team1.get_extra()<<endl<<endl;
    cout<<"\n\n--------------------------------------------------"<<endl;
    cout<<"Over "<<Over<<"."<<Ball_count<<"  Wicket "<<Out;
    cout<<" || total score: ";
    cout<<team1.get_Total()<<endl;
    cout<<(oppScore+1)-(team1.get_Total())<<" runs more required to win...."<<endl;

    cout<<"\nEnter a number between 0 to 6 or 7 to EXIT"<<endl;

    while(1){
        cin>>input1;
        srand(time(NULL));
        input2=comp_input(levelType);
        if(input1>7||input1<0);
        else break;
    }

    if(input1==7) option=7;
    else option=outcome(input1,input2);

    switch (option){
        case 2:    add_run();   break;
        case 3:    extra1();  break;
        case 4:    wicket();  break;
        case 7:    return;
    }
}



/***************** Add Extra Run *********************/
void myscore::extra1(void){
    char ch;
    cout<<"\n\n**********************************\n";
    if(input1==0)
        cout<<"             Wide Ball             \n";
    else
        cout<<"             No Ball             \n";
    cout<<"**********************************\n\n";
    cout<<"Enter a character to continue............\n";
    cin>>ch;
    extra=1;
    team1.Set_Extra(extra);
    show();
}

/****************** Add Current Player Run******************/
void myscore::add_run(void){
    int runs;
    char ch;

    Ball_count++;

    team1.Set_Ball(player1);

    if(levelType==3) runs=run_pro(input1,input2);
    else runs=run_nonpro(input1);
    cout<<"\n\n**********************************\n";
    cout<<"        Batsmen scored "<<runs<<" runs\n";
    cout<<"**********************************\n\n";
    cout<<"Enter a character to continue............\n";
    cin>>ch;

    team1.Add_Run(player1,runs);

    if(runs==1||runs==3)
    {
        int temp = player1;
        player1=player2;
        player2=temp;
    }

    if(oppScore<team1.get_Total())
    {
        cout<<"\n\n************************************************\n";
        cout<<"    Congratulations you have won the match   \n";
        cout<<"************************************************\n";

        return;
    }

    if(Ball_count==6)
        {
            over_complete();
            return;
        }

    show();
}

/***************** Over Complete ***************************/
void myscore::over_complete(void)
{
    cout<<"\n\n*********************************\n";
    cout<<"           Over Complete\n";
    cout<<"*********************************\n";
    Over++;
    Ball_count=0;

    int temp = player1;
    player1=player2;
    player2=temp;

    if(oppScore<team1.get_Total())
    {
        cout<<"\n\n*************************************************\n";
        cout<<"    Congratulations you have won the match   \n";
        cout<<"************************************************\n";

        return;
    }

    else if(Over==Max_Over)
    {
        cout<<"\n\n********************************************\n";
        cout<<" You Lost the game.... Better luck next time \n";
        cout<<"**********************************************\n";

        return;
    }

    else show();
}


/********************** Wicket Fallen ************************/
void myscore::wicket(void)
{
    int o_type,new_player;
    o_type=wicket1(input1);
    cout<<"\n\n*********************************\n";
    if(o_type==0)
        cout<<"     Wicket LBW \n";
    else if(o_type==1)
        cout<<"     Wicket Run Out \n";
    else if(o_type==2)
        cout<<"     Wicket Bowled Out\n";
    else
        cout<<"     Wicket Caught Out\n";
    cout<<"*********************************\n";
    Out++;
    Ball_count++;
    team1.Set_Ball(player1);

    if(oppScore<team1.get_Total())
    {
        cout<<"\n\n************************************************\n";
        cout<<"    Congratulations you have won the match   \n";
        cout<<"************************************************\n";

        return;
    }

    else if(Out>=Max_out)
    {
        cout<<"\n\n********************************************\n";
        cout<<" You Lost the game.... Better luck next time \n";
        cout<<"**********************************************\n";

        return;
    }

    cout<<"\nNew Batsmans no: ";
    cin>>new_player;
    team1.Set_Out(player1,o_type+2,new_player);
    player1=new_player;

    if(Ball_count==6){
        over_complete();
        return;
    }

    show();
}
void myscore::autoScore()
{
    int maxball=Max_Over*6,cwic=0;
    int p1,p2;

    oppScore=0;
    srand(time(NULL));

    for(int i=0;i<maxball && cwic<11;i++)
    {
        p1=amateur_random();
        p2=amateur_random();

        if(p1==p2)
            cwic++;
        else if(p2==0 && (p1==0||p1==6))
        {
            oppScore++;
            i--;
        }
        else
            oppScore+=p1;
    }

    cout<<"Your opponent has scored "<<oppScore<<endl;
    cout<<"Your chance to take the challenge.."<<endl;
}
