#include<iostream>
using namespace std;
#include<stdlib.h>
#include<stdio.h>
#include<cstring>
#include<cstdio>
#include "SCcommon.h"

 struct teamplayers
 {
    char name[30];
    int type;
    int p_run;
    int p_status;
    int p_ball;
 };

struct team
 {
    char name[20];
    teamplayers player [11];
    int pNum;
    int extraRun;
 };

struct teammanagement
 {
    int teamtype;
    team t;

    void printteam();
    void func1();
    void func2();
    void func3();

    void management();
    char* get_name(int i){return t.player[i].name;}
    int get_run(int i){return t.player[i].p_run;}
    int get_status(int i){return t.player[i].p_status;}
    int get_extra(void){return t.extraRun;}
    int get_ball(int i){return t.player[i].p_ball;}
    char* get_t_name(){return t.name;}
    int get_Total(void);
    void Add_Run(int player_num,int run);
    void Set_Status(int player,int status){t.player[player].p_status=status;};
    void Set_Out(int out_player,int type,int new_player);
    void Set_Ball(int player){t.player[player].p_ball++;}
    void Set_Extra(int run){t.extraRun+=run;};
 };

 void teammanagement::management()
     {
         switch(teamtype)
         {
             case 1:
                 func1();
                 break;

             case 2:
                 func2();
                 break;

             case 3:
                func3();
                break;
         }
     }

 void teammanagement::func1()
 {
     FILE *f1;
     bool check;
     int numPlayers,Values[7]={0};
     string name;

     do
        {
            cout<<"1. India"<<endl;
            cout<<"2. Pakistan"<<endl;
            cout<<"3. Australia"<<endl;
            cout<<"4. SriLanka"<<endl;
            cout<<"5. England"<<endl;

            cin>>numPlayers;

            for(int i=0;i<5;i++)
                Values[i]=i+1;

            check=Validate(Values,numPlayers);
            for(int i=0;i<5;i++)
                Values[i]=0;
        } while(check);

        switch(numPlayers)
        {
            case 1:
                   name="India";
                   break;
            case 2:
                   name="Pakistan";
                   break;
            case 3:
                   name="Australia";
                   break;
            case 4:
                   name="SriLanka";
                   break;
            case 5:
                   name="England";
                   break;
        }

        strncpy(t.name,name.c_str(),sizeof(t.name));

        f1=fopen(t.name,"r");
        int i=0;

        if(f1==NULL)
        {
            cout<<"Could not open team file"<<endl;
            exit(EXIT_FAILURE);
        }

        while(i!=11)
        {
            fscanf(f1,"%d",&t.player[i].type);
            fgets(t.player[i].name,29,f1);
            t.player[i].p_run=0;
            t.player[i].p_status=0;
            t.player[i].p_ball=0;
            i++;
        }

        t.extraRun=0;
        t.pNum=0;

        printteam();
}

void teammanagement::func2()
{
    string name;

    cout<<"Enter your team name(Less than 20 characters)"<<endl;
    cin>>name;
    strncpy(t.name,name.c_str(),sizeof(t.name));

    char c[20]="instud.txt";
    printInstruction(c);

    cout<<"Enter the players as specified in the instruction"<<endl;

    for(int j=0;j<11;j++)
    {
        bool check;
        int Values[7]={0},k=0;

        t.player[j].name[0]=getchar();
        gets(t.player[j].name);

        do
        {
            cin>>t.player[j].type;

            for(int i=0;i<4;i++)
                Values[i]=i+1;

            check=Validate(Values,t.player[j].type);
            for(int i=0;i<4;i++)
                Values[i]=0;
        } while(check);
        t.player[j].p_run=0;
        t.player[j].p_status=0;
        t.player[j].p_ball=0;
    }

    t.extraRun=0;
    t.pNum=0;

    printteam();
}

void teammanagement::func3()
{
    int j;
    func1();

    while(1)
    {
        cout<<"Enter the player number you want to modify(0 to finish modifying)"<<endl;
        cin>>j;
        if(j==0) break;
        else if(j<11&&j>1){
            cout<<"Enter the players name"<<endl;
            t.player[j].name[0]=getchar();
            gets(t.player[j-1].name);
            system("cls");
            printteam();
        }
        else cout<<"Invalid Input"<<endl;

    }
}

void teammanagement::printteam()
{
    cout<<"Your team "<<t.name<<" :"<<endl;

        for(int i=0;i<11;i++)
        {
            cout<<i+1<<". ";
            puts(t.player[i].name);
        }
}


void teammanagement::Add_Run(int player_num,int run)
{
  t.player[player_num].p_run += run;
  get_Total();
}


/*************** Calculate & Get Total Run ************/
int teammanagement::get_Total(){
  int local_total=0;
  for(int i=0;i<=10;i++)
    local_total += t.player[i].p_run;           //Players Score
  local_total += t.extraRun;                    //Add Extra

  return local_total;
}


void teammanagement::Set_Out(int out_player,int type,int new_player){
   t.player[out_player].p_status=type;             //Current Player out
   t.player[new_player].p_status=1;                //New Player Not out
}
